import { interfaces } from 'inversify';
import { AbstractViewContribution, FrontendApplication, FrontendApplicationContribution } from '@theia/core/lib/browser';
import { GettingStartedWidget } from '@theia/getting-started/lib/browser/getting-started-widget';
import { FrontendApplicationStateService } from '@theia/core/lib/browser/frontend-application-state';
import { FxdkWorkspaceService } from '../rebindWorkspaceService';
import { Command, CommandRegistry, MenuModelRegistry } from '@theia/core';
import { FxdkDataService } from 'fxdk-services/lib/browser/fxdk-data-service';
export declare namespace FxdkHelpCommands {
    const DOCUMENTATION_LINK: Command;
    const NATIVES_LINK: Command;
    const FORUMS_LINK: Command;
}
export declare class FxdkHelpContribution extends AbstractViewContribution<GettingStartedWidget> implements FrontendApplicationContribution {
    protected readonly stateService: FrontendApplicationStateService;
    protected readonly workspaceService: FxdkWorkspaceService;
    protected readonly dataService: FxdkDataService;
    constructor();
    onStart(app: FrontendApplication): Promise<void>;
    registerCommands(registry: CommandRegistry): void;
    registerMenus(menus: MenuModelRegistry): void;
}
export declare function rebindHelpContribution(bind: interfaces.Bind, rebind: interfaces.Rebind): void;
//# sourceMappingURL=rebindHelpContribution.d.ts.map